// AddAutoPasswordButtons: Look for password boxes and add a generate password button next to tehm
function AddAutoPasswordButtons() {
	// Don't add the Generate button to certain pages where it wouldn't make sense
	var NoGenerate = [
		'WHMCS - Servers',
		'WHMCS - Support Ticket Departments'
	];
	for (i=0; i<NoGenerate.length; i++) if (document.title == NoGenerate[i]) return;
	
	// Get the Password text box, if there is one
	var e = document.getElementsByName("password");
	if (e.length>0)
	{
		var b = document.createElement("input");
		b.type    = "button";
		b.value   = "Generate";
		b.onclick = GeneratePassword;
		e[0].parentNode.appendChild(b);
	}
}

// GeneratePassword: Generate a password and place it in a textbox
function GeneratePassword() {
	var p = GetRandomPassword();
	var e = document.getElementsByName("password");
	if (e.length>0) {
		e[0].value = p;
		if (e[0].type == "password") e[0].type = "text";
	}
	// For a "confirm password" field
	e = document.getElementsByName("password2");
	if (e.length>0) {
		e[0].value = p;
		if (e[0].type == "password") e[0].type = "text";
	}
}

// GetRandomNumber: Get a random number between two specified numbers
function GetRandomNumber(lbound,ubound) {
	return (Math.floor(Math.random() * (ubound-lbound)) + lbound);
}

// GetRandomCharacter: Get a random character
function GetRandomCharacter() {
	var chars = ""; // Choose your character sets below
	chars += "0123456789";
	chars += "abcdefghijklmnopqrstuvwxyz";
	chars += "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	
	return chars.charAt(GetRandomNumber(0,chars.length));
}

// GetRandomPassword: Get a random password
function GetRandomPassword() {
	var p = "";
	for (i=0; i<8; i++) p += GetRandomCharacter();
	return p;
}

//------------------------------------------------------------------------------

// Adding events to onLoad
// Source: http://onlinetools.org/articles/unobtrusivejavascript/chapter4.html
function addEvent(obj, evType, fn){ 
 if (obj.addEventListener){ 
   obj.addEventListener(evType, fn, false); 
   return true; 
 } else if (obj.attachEvent){ 
   var r = obj.attachEvent("on"+evType, fn); 
   return r; 
 } else { 
   return false; 
 } 
}

// Hook AddAutoPasswordButtons to window load
addEvent(window,'load',AddAutoPasswordButtons);